#ifndef MY_LCD_H
#define MY_LCD_H

/*
     2-  16 , HD44780- -  4-  . 
  : CodeVisionAVR 1.24.8b.

///////////////////////////////////////////////////__//////////////////////////////////////////////////////////
  
||___||  
     E      -   PORTx 4*
     RS     -   PORTx 5 
     
     D4     -   PORTx 0 
     D5     -   PORTx 1 
     D6     -   PORTx 2 
     D7     -   PORTx 3

*  , x -  A/B//D/E/F...   .

        ( )

////////////////////////////////////////////////_ _////////////////////////////////////////////////////

,    -  : #define LCD_PORT PORTn
                                                             #define LCD_DDR  DDRn								
 PORTA:

#define LCD_PORT PORTA
#define LCD_DDR  DDRA
#include <My_Lcd.h>

/////////////////////////////////////////////////////__//////////////////////////////////////////////////////

  :

    -  ,         LCD_Init(),
         ,(     
   ))     LCD_CursorPos(row,column),  "row"  ,  "column"   
\.          -?      :

- LCD_SendChar -   ASCII . : LCD_SendChar('H');

- LCD_SendStr_S -     (SRAM). : char buffer[] = "Hello world!";
                                                               LCD_SendStr_S((buffer);  

- LCD_SendStr_F -     -. : LCD_SendStr_F("Hello world!");

  . ,     sprintf*   stdio.h  
CodeVisionAVR. : char temp;
                       char buffer[15];
                       temp = 5*5; 
                       sprintf(buffer,"%u",temp);**                                                                                                                      
                       LCD_SendStr_S(buffer);

* 1:     sprintf     .
* 2:        ISIS,       
(s)printf Features   Project->Configure->C Compilier,   "long,width".

     DDRAM (      )  8  ( $40  $7F), 
       .         
 .    . ,    .   HD44780      
.       :

flash char Smile[8] = {0x00, 0x0A, 0x0A, 0x00, 0x11, 0x0E, 0x06, 0x00};

  ,      -,      LCD_WriteMyChar - 
LCD_WriteMyChar(Smile,0);  0 -  ,       8 ,       
 0  7.

     ,    - LCD_Clear();   
*/ 

//**********************************| Hitachi HD44780- .|*************************************//
//------------------------------------------------------------------------------------------------------------------------
#define CLEAR_LCD 		    0x01  // .

#define RETURN_TO_HOME		0x02  //      (1- , 1- ).

#define ENTRY_LEFT		    0x04  //     .
#define ENTRY_RIGHT		    0x06  //     .

#define LCD_ON			    0x0C  //  .
#define BLINK_CHAR_ON	    0x0D  //  +    .
#define CURSOR_ON			0x0E  //  +  .
#define BLINK_CURSOR_ON		0x0F  //  +  .

#define SHIFT_CURSOR_LEFT	0x10  //         DDRAM.
#define SHIFT_CURSOR_RIGHT	0x14  //         DDRAM.
#define SHIFT_DISPLAY_LEFT	0x18  //         DDRAM.
#define SHIFT_DISPLAY_RIGHT	0x1C  //         DDRAM.

#define MODE_8_BITS		    0x38  //8-  .		
#define MODE_4_BITS		    0x22  //4-  .
#define MODE_2_LINES		0x28  //4-  , 2.
//------------------------------------------------------------------------------------------------------------------------
//*.          . LCD_SendCom. : LCD_SendCom(BLINK_CURSOR_ON);
//------------------------------------------------------------------------------------------------------------------------
 
#include <delay.h>

									  											
#define SET_E          LCD_PORT.4 = 1    //E=1
#define CLEAR_E        LCD_PORT.4 = 0    //E=0 
			
#define SET_DATA       LCD_PORT.5 = 1    //RS=1												
#define SET_COMMANDS   LCD_PORT.5 = 0    //RS=0	 
								
const unsigned char rowAdress[4] = {0x80, 0xC0, 0x94, 0xD4};
 
void LCD_Init(void);
void LCD_Clear(void);
void LCD_CursorPos(unsigned char row,unsigned char col);
void LCD_WriteMyChar(unsigned char flash *s, unsigned char adress);

void LCD_SendNibble(unsigned char data);
void LCD_SendByte(unsigned char data);
void LCD_SendCom(unsigned char command);

void LCD_SendChar(unsigned char data);
void LCD_SendStr_S(unsigned char *str);
void LCD_SendStr_F(unsigned char flash *data);


/*****************************************************************************
*
*     : LCD_SendNibble
*
*    : data -   .
*
*     : . 
*                           
*    :   -  .
*              4-   ,    
*               . (.  LCD_Init).  
*            
*                        
*****************************************************************************/ 

void LCD_SendNibble(unsigned char data)
{
    SET_COMMANDS;

    SET_E;
    LCD_PORT = (data & 0x0F);
    CLEAR_E;

    delay_us(3000);
}  


/*****************************************************************************
*
*     : LCD_SendByte
*
*    : data -   .
*
*     : .
*                           
*    :      .
*            
*                        
*****************************************************************************/ 

void LCD_SendByte(unsigned char data)
{
    SET_E;
    LCD_PORT &= 0xF0;
    LCD_PORT |= (data >> 4);
    CLEAR_E;
  
    delay_ms(1);
   
    SET_E;
    LCD_PORT &= 0xF0;
    LCD_PORT |= (data & 0x0F);
    CLEAR_E;
     
    delay_us(3000);
}  


/*****************************************************************************
*
*     : LCD_SendCom
*
*    : command -  (    
*                 )  .
*
*     : .
*                           
*    :      HD44780-
*            .
*            
*                        
*****************************************************************************/ 

void LCD_SendCom(unsigned char command)
{
    SET_COMMANDS;
    LCD_SendByte(command);
}


/*****************************************************************************
*
*     : LCD_SendChar
*
*    : data -     .
*
*     : .
*                           
*    :   ASCII.
*            
*                        
*****************************************************************************/ 

void LCD_SendChar(unsigned char data)
{
    SET_DATA;
    LCD_SendByte(data);
}  


/*****************************************************************************
*
*     : LCD_SendStr_S
*
*    : *str -      SRAM  .
*
*     : .
*                           
*    :      
*             SRAM ()  .
*            
*                        
*****************************************************************************/ 

void LCD_SendStr_S(unsigned char *str)
{
    while(*str != 0)
    {
        LCD_SendChar(*str);
        str++;
    }
}


/*****************************************************************************
*
*     : LCD_SendStr_F
*
*    : *str -      FLASH  .
*
*     : .
*                           
*    :      
*             FLASH ()  .
*                ( .  flash).
*                        
*                        
*****************************************************************************/ 

void LCD_SendStr_F(char flash *str)
{
    while(*str != 0)
    {
        LCD_SendChar(*str);
        str++;
    }
}


/*****************************************************************************
*
*     : LCD_WriteMyChar
*
*    : *data -     8   
*                .
*               adress -   0  7     . 
*
*     : .
*                           
*    :      8  
*              . 
*            
*                        
*****************************************************************************/ 

void LCD_WriteMyChar(unsigned char flash *data, unsigned char adress)
{
  unsigned char i;
 
    adress = (0x40 + (adress * 8));  //adress = 0x40 | (adress << 3);  
  
    for(i=0; i<8; i++)
    { 
        LCD_SendCom(adress);	
        LCD_SendChar(*data);
        adress++;
        data++;	
    }
}


/*****************************************************************************
*
*     : LCD_CursorPos
*
*    : row - .
*               col - /.
*
*     : .
*                           
*    :        .
*            
*                        
*****************************************************************************/ 

void LCD_CursorPos(char row, char col)
{
    LCD_SendCom(rowAdress[row-1] + col);
}


/*****************************************************************************
*
*     : LCD_Clear
*
*    : .
*
*     : .
*                           
*    :    .
*            
*                        
*****************************************************************************/ 

void LCD_Clear(void)
{   
    LCD_SendCom(CLEAR_LCD);
    delay_ms(10); 
}         


/*****************************************************************************
*
*     : LCD_Init
*
*    : .
*
*     : .
*                           
*    : .
*            
*                        
*****************************************************************************/ 
 
void LCD_Init(void)
{
    LCD_DDR |= 0x3F;
  
    CLEAR_E;
    delay_ms(50);

    LCD_SendNibble(MODE_8_BITS);
    LCD_SendNibble(MODE_8_BITS);
    LCD_SendNibble(MODE_8_BITS);
    LCD_SendNibble(MODE_4_BITS);

    LCD_SendCom(MODE_2_LINES);
    LCD_SendCom(ENTRY_RIGHT);
    LCD_SendCom(LCD_ON);
}


#endif
