
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

void SDA_SET(unsigned char status)
{
if(status == 1)
{
DDRB									   .1									    = 0;
PORTB								   .1									    = 0;  
}
else
{
DDRB									   .1									    = 1;
PORTB								   .1									    = 0;
}

delay_us(5);
}     

void SCL_SET(unsigned char status)
{
if(status == 1)
{
DDRB									   .0									    = 0;
PORTB								   .0									    = 0;
}   
else
{
DDRB									   .0									    = 1;
PORTB								   .0									    = 0;
}

delay_us(5);
} 

void I2C_Start(void)
{ 
SDA_SET(1); 
SCL_SET(1);  
SDA_SET(0);                                 
}             

void I2C_Stop(void)
{ 
SDA_SET(0);  
SCL_SET(1);
SDA_SET(1);
}

unsigned char I2C_WriteByte(unsigned char data_byte)
{
unsigned char i;
unsigned char data_bit;        
unsigned char ack_status;      

for(i=0; i<8; i++)           
{ 
data_bit = data_byte;          
data_bit = (data_bit << i);    

data_bit = (data_bit & 0b10000000);   

SCL_SET(0);              

if(data_bit == 0)        
SDA_SET(0);          
else               
SDA_SET(1);      

SCL_SET(1);          
}				     

SCL_SET(0);              

DDRB									   .1									    = 0;	    

SCL_SET(1);                   

if(PINB									  .1									    == 0)   
ack_status = 1;
else                    
ack_status = 0;             

SCL_SET(0);              

DDRB									   .1									    = 1;     

return ack_status;         
}

unsigned char I2C_ReadByte(unsigned char ack_status)
{ 
unsigned char data_byte = 0;       
unsigned char i;

DDRB									   .1									    = 0;             

for(i=8; i>0; i--)               
{
SCL_SET(1);                  

if(PINB									  .1									    == 1)  
{				       
data_byte |= (1<<(i-1));  
}				       

SCL_SET(0);                   
}

SCL_SET(0);                  

if(ack_status == 1)        
SDA_SET(0);		   
else		         
SDA_SET(1);		   

SCL_SET(1);                  
SCL_SET(0);			   

return data_byte;              
}

unsigned char i;               

void T190_INIT(void){ 
DDRB.2 = 1;
PORTB.2 = 1;
I2C_Start();
I2C_WriteByte(0x78   );     
I2C_WriteByte(0x00);  
I2C_WriteByte(0x31);  
I2C_WriteByte(0x14);  
I2C_WriteByte(0x06);  
I2C_WriteByte(0x30);  
I2C_WriteByte(0x11);  
I2C_WriteByte(0x05);  
I2C_WriteByte(0x31);  
I2C_WriteByte(0x9A);  
I2C_WriteByte(0x0C);  
I2C_WriteByte(0x30);  
I2C_WriteByte(0x0C);  
I2C_WriteByte(0x40);  
I2C_WriteByte(0x80);  
I2C_Stop();           
delay_ms(10);  
I2C_Start();
I2C_WriteByte(0x78   );  
I2C_WriteByte(0x00);  
I2C_WriteByte(0x31);  
I2C_WriteByte(0x00);  
I2C_Stop();           

}

void T190_Clear_Line(void){
unsigned char j;
I2C_Start();
I2C_WriteByte(0x78   );     
I2C_WriteByte(0x40);               
for(j=0;j<97;j++){
I2C_WriteByte(0x00);             
}
I2C_Stop(); 
}

void T190_CLS(void){
for(i=0x40;i<0x48;i++){
I2C_Start();
I2C_WriteByte(0x78   );     
I2C_WriteByte(0x00);               
I2C_WriteByte(0x30);               
I2C_WriteByte(i);                  
I2C_WriteByte(0x80);               
I2C_Stop();
T190_Clear_Line();                 
}  
}

void main(void)
{  

TCCR0=0x00;
TCNT0=0x00;

TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

MCUCR=0x00;

TIMSK=0x00;

ACSR=0x80;
SFIOR=0x00;

T190_INIT();
T190_CLS();

I2C_Start();
I2C_WriteByte(0x78   );     
I2C_WriteByte(0x00);  
I2C_WriteByte(0x30);  
I2C_WriteByte(0x43);  
I2C_WriteByte(0xB0);  
I2C_Stop();

I2C_Start();
I2C_WriteByte(0x78   );     
I2C_WriteByte(0x40);  
I2C_WriteByte(0x00);  
I2C_WriteByte(0x01);  
I2C_WriteByte(0x02);  
I2C_WriteByte(0x04);  
I2C_WriteByte(0x08);  
I2C_WriteByte(0x10);  
I2C_WriteByte(0x20);  
I2C_WriteByte(0x40);  
I2C_WriteByte(0x80);  
I2C_Stop();

while(1)
{

}
}
