.include "m8def.inc"
//
.EQU 	clock=0
.EQU 	reset=2
.EQU	data=1
.def 	temp1=r16
.def 	temp2=r17
.def	temp3=r18
.def	temp4=r19
//
.MACRO clock_pulse
		sbi		PORTB,clock
		rcall	delay_short
		cbi 	PORTB,clock
		rcall	delay_short
.ENDMACRO

.MACRO	i2c_out
		ldi		temp1,@0
		rcall	i2c_sb
.ENDMACRO

.MACRO	drbyte
		ldi		temp1,@0
		rcall	i2c_db
.ENDMACRO

.MACRO	drsym
		ldi		temp1,@0
		rcall	draw_symbol
.ENDMACRO

.MACRO 	scur		//@0,temp2 - X		@1,temp3 - Y
		ldi		temp2,@0
		ldi		temp3,@1
		rcall	set_cur
.ENDMACRO

.MACRO	sfocus
		ldi		temp1,@0
		sts		focus,temp1
.ENDMACRO
		.dseg
xcur: 	.byte	1
ycur:	.byte	1
ycur2:	.byte	1
		.eseg
		.cseg
// 
		ldi		temp1, low(RAMEND)
		out		SPL, temp1
		ldi 	temp1, high(RAMEND)
		out  	SPH, temp1
//  -
		ldi		temp1,0b00000111		//DDR
		out		DDRB,temp1
		ldi 	temp1,0b00000000		//PORT
		out 	PORTB,temp1

// 
		// 
begin:	ldi		temp1,0x00		//    0
		sts		xcur,temp1
		sts		ycur,temp1
		sts		ycur2,temp1		//   0
cycle1:	sbi		PORTB,reset
		rcall	i2c_start
		i2c_out	0x78
		i2c_out	0x00
		i2c_out	0x31
		i2c_out	0x14
		i2c_out	0x06
		i2c_out 0x30
		i2c_out	0x11
		i2c_out	0x05
		i2c_out	0x31
		i2c_out	0x9A
		i2c_out 0x0C
		i2c_out 0x30
		i2c_out 0x0C
		i2c_out 0x40
		i2c_out 0x80
		rcall	i2c_stop
		// 
		rcall	i2c_start
		i2c_out	0x78
		i2c_out	0x00
		i2c_out	0x31
		i2c_out	0
		rcall	i2c_stop
		rcall	clr_screen
		scur	0,0
		ldi		temp1,0b10000000
		sts		ycur,temp1
		sts		ycur2,temp1
		rcall	read_eepr
e1:		sbis	PINB,6
		rjmp	e2
		rcall	clr_screen
		scur	0,0			//    1 
		lds		temp1,ycur2
		inc		temp1
		inc		temp1
		inc		temp1
		sts		ycur,temp1
		sts		ycur2,temp1
		//EEPROM 
		rcall	read_eepr
e2:		sbis	PINB,7
		rjmp	e1
		lds		temp1,ycur2
		cpi		temp1,0b10000000
		breq	e2
		rcall	clr_screen
		scur	0,0			//    1 
		lds		temp1,ycur2
		dec		temp1
		dec		temp1
		dec		temp1
		sts		ycur,temp1
		sts		ycur2,temp1
		//EEPROM 
		rcall	read_eepr
		rjmp	e1
end:	rjmp	end
//
delay_short:nop
		ret

delay_long:push temp1
		push	temp2
		push	temp3		
		ldi 	temp1,5
wait1:	dec		temp1
		breq	end2
		ldi		temp2,80
wait2:	dec		temp2
		breq	wait1
		ldi		temp3,255
wait3:	dec		temp3
		brne	wait3
		rjmp	wait2	
end2:	pop		temp3
		pop		temp2
		pop		temp1
		ret

// 
i2c_sb:push	temp2
		push	temp1
		ldi		temp2,0
out2:	bst		temp1,7					// 7-   temp1   
		push	temp2					// temp2  
		in		temp2,PORTB				//  temp2  PORTB
		bld		temp2,data				//   data  
		out		PORTB,temp2				//  temp2   PORTB
		clock_pulse						//   clock
		pop		temp2					// temp2  
		lsl		temp1					//   temp1 
		inc		temp2					// temp2  1
		CPI		temp2,8					//  temp2  
		breq	out_end					// 8    
		rjmp	out2					//   out2
out_end:cbi		PORTB,data
		sbi		PORTB,clock				// 
		rcall	delay_short
		rcall	delay_short
		cbi		PORTB,clock
		pop		temp1
		pop		temp2
		ret
//     -   
i2c_db:	push	temp3
		push	temp2
		push	temp1
		push	temp1
		lds		temp3,ycur
		bst		temp3,7
		brtc	c1
c2:		cpi		temp3,0b10000000
		breq	c1
		pop		temp1
		rjmp	dbout_end3
c1:		rcall	i2c_start
		i2c_out	0x78
		i2c_out	0x40
		pop		temp1
		ldi		temp2,0
dbout2:	bst		temp1,7					// 7-   temp1   
		push	temp2					// temp2  
		in		temp2,PORTB				//  temp2  PORTB
		bld		temp2,data				//   data  
		out		PORTB,temp2				//  temp2   PORTB
		clock_pulse						//   clock
		pop		temp2					// temp2  
		lsl		temp1					//   temp1 
		inc		temp2					// temp2  1
		CPI		temp2,8					//  temp2  
		breq	dbout_end					// 8    
		rjmp	dbout2					//   out2
dbout_end:cbi	PORTB,data
		sbi		PORTB,clock				// 
		rcall	delay_short
		cbi		PORTB,clock
		rcall	i2c_stop
dbout_end3:lds	temp1,xcur
		inc		temp1
		sts		xcur,temp1
		cpi		temp1,100		//,          ,    100,   
		brne	dbout_end2
		ldi		temp1,0b00000000// X  ,    
		sts		xcur,temp1
		lds		temp1,ycur		// Y
		inc		temp1
		sts		ycur,temp1
		lds		temp2,xcur
		lds		temp3,ycur
		rcall	set_cur
dbout_end2:pop		temp1
		pop		temp2
		pop		temp3
		ret
		
i2c_start:sbi		PORTB,data
		rcall	delay_short
		sbi		PORTB,clock
		rcall	delay_short
		cbi		PORTB,data
		rcall	delay_short
		cbi		PORTB,clock
		ret

i2c_stop:cbi		PORTB,data
		cbi		PORTB,clock
		rcall	delay_short
		sbi		PORTB,clock
		rcall	delay_short
		sbi		PORTB,data
		rcall	delay_short
		ret

clear_line:rcall	i2c_start
		i2c_out 0x78
		i2c_out	0x40
		ldi		temp1,98
mark:	push	temp1
		i2c_out	0b00000000
		pop		temp1
		dec		temp1
		brne	mark
		rcall	i2c_stop
		ret

// 
// temp1  
draw_symbol:
		cpi		temp1,46
		breq	mark2
		push	temp1
		lds		temp1,xcur
		cpi		temp1,93		//,    
		brmi	mark1
		ldi		temp1,0b00000000// X  ,    
		sts		xcur,temp1
		lds		temp1,ycur		// Y
		bst		temp1,7
		brts	a1
		inc		temp1
		sts		ycur,temp1
		rjmp	a2
a1:		andi	temp1,0b01111111
		tst		temp1
		brne	a3
		scur	0,1
		rjmp	mark1
a3:		dec		temp1
		ori		temp1,0b10000000
		sts		ycur,temp1
		rjmp	mark1		
a2:		lds		temp2,xcur
		lds		temp3,ycur
		rcall	set_cur
mark1:	pop		temp1
		cpi		temp1,0
		brne	mark2
		drbyte	0b00111110
		drbyte	0b01000001
		rcall	i2c_db
		drbyte	0b00111110
		rjmp	end_drawsymbol
mark2:	cpi		temp1,1
		brne	mark3
		drbyte	0b01000010
		drbyte  0b01111111
		drbyte	0b01000000
		rjmp	end_drawsymbol
mark3:	cpi		temp1,2
		brne	mark4
		drbyte	0b01000010
		drbyte	0b01100001
		drbyte	0b01010001
		drbyte 0b01001001
		drbyte	0b01000110
		rjmp	end_drawsymbol
mark4:	cpi		temp1,3
		brne	mark5
		drbyte	0b00100010
		drbyte	0b01001001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00110110
		rjmp	end_drawsymbol
mark5:	cpi		temp1,4
		brne	mark6
		drbyte	0b00011000
		drbyte	0b00010100
		drbyte	0b00010010
		drbyte	0b01111111
		drbyte	0b00010000
		rjmp	end_drawsymbol
mark6:	cpi		temp1,5
		brne	mark7
		drbyte	0b00101111
		drbyte	0b01001001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00110001
		rjmp	end_drawsymbol
mark7:	cpi		temp1,6
		brne	mark8
		drbyte	0b00111110
		drbyte	0b01001001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00110000
		rjmp	end_drawsymbol
mark8:	cpi		temp1,7
		brne	mark9
		drbyte	0b01000001
		drbyte	0b00110001
		drbyte 0b00001101
		drbyte	0b00000011
		rjmp	end_drawsymbol
mark9:	cpi		temp1,8
		brne	mark10
		drbyte	0b00110110
		drbyte	0b01001001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00110110
		rjmp	end_drawsymbol
mark10:	cpi		temp1,9
		brne	mark11
		drbyte	0b00001110
		drbyte	0b01010001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00111110
mark11:	cpi		temp1,10		//+
		brne	mark12
		drbyte	0b00001000
		rcall	i2c_db
		drbyte	0b00111110
		drbyte	0b00001000
		rcall	i2c_db
		rjmp	end_drawsymbol
mark12:	cpi		temp1,11		//-
		brne	mark13
		drbyte	0b00001000
		rcall	i2c_db
		rcall	i2c_db
		rcall	i2c_db
		rcall	i2c_db
		rjmp	end_drawsymbol
mark13:	cpi		temp1,12		//=
		brne	mark14
		drbyte	0b00010100
		rcall	i2c_db
		rcall	i2c_db
		rcall	i2c_db
		rcall	i2c_db
		rjmp	end_drawsymbol
mark14:	cpi		temp1,13		//.
		brne	mark15
		drbyte	0b01100000
		rcall	i2c_db
		rjmp	end_drawsymbol
mark15:	cpi		temp1,14		//?
		brne	mark16
		drbyte	0b00000011
		drbyte	0b01101001
		rcall	i2c_db
		drbyte	0b00001001
		drbyte	0b00000110
		rjmp	end_drawsymbol
mark16:	cpi		temp1,15		//!
		brne	mark17
		drbyte	0b01101111
		rcall	i2c_db
		rjmp	end_drawsymbol
mark17:	cpi		temp1,16		//:
		brne	mark18
		drbyte	0b01100110
		rcall	i2c_db
		rjmp	end_drawsymbol
mark18:	cpi		temp1,17		//,
		brne	mark19
		drbyte	0b10110000
		drbyte	0b01110000
		rjmp	end_drawsymbol
mark19:	cpi		temp1,18		//
		brne	mark20
		drbyte	0x00
		rcall	i2c_db
		rcall	i2c_db
		rcall	i2c_db
		rjmp	end_drawsymbol
mark20:	cpi		temp1,19		//A
		brne	mark21
		drbyte	0b01111110
		drbyte	0b00010001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b01111110
		rjmp	end_drawsymbol
mark21:	cpi		temp1,20		//B
		brne	mark22
		drbyte 	0b01111111
		drbyte 	0b01001001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00110110
		rjmp	end_drawsymbol
mark22:	cpi		temp1,21		//C
		brne	mark23
		drbyte	0b00111110
		drbyte	0b01000001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00100010
		rjmp	end_drawsymbol
mark23:	cpi		temp1,22		//D
		brne	mark24
		drbyte	0b01111111
		drbyte	0b01000001
		rcall	i2c_db
		drbyte	0b00100010
		drbyte	0b00011100
		rjmp	end_drawsymbol
mark24:	cpi		temp1,23		//E
		brne	mark25
		drbyte	0b01111111
		drbyte	0b01001001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b01000001
		rjmp	end_drawsymbol
mark25:	cpi		temp1,24		//F
		brne	mark26
		drbyte	0b01111111
		drbyte	0b00001001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00000001
		rjmp	end_drawsymbol
mark26:	cpi		temp1,25		//G
		brne	mark27
		drbyte	0b00111110
		drbyte	0b01000001
		drbyte	0b01010001
		rcall	i2c_db
		drbyte	0b00100010
		rjmp	end_drawsymbol
mark27:	cpi		temp1,26		//H
		brne	mark28
		drbyte	0b01111111
		drbyte	0b00001000
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b01111111
		rjmp	end_drawsymbol
mark28:	cpi		temp1,27		//I
		brne	mark29
		drbyte	0b01000001
		drbyte	0b01111111
		drbyte	0b01000001
		rjmp	end_drawsymbol
mark29:	cpi		temp1,28		//J
		brne	mark30
		drbyte	0b00110001
		drbyte	0b01000001
		drbyte	0b00111111
		drbyte	0b00000001
		rjmp	end_drawsymbol
mark30:	cpi		temp1,29		//K
		brne	mark31
		drbyte	0b01111111
		drbyte	0b00001000
		drbyte	0b00010100
		drbyte	0b00100010
		drbyte	0b01000001
		rjmp	end_drawsymbol
mark31:	cpi		temp1,30		//L
		brne	mark32
		drbyte	0b01111111
		drbyte	0b01000000
		rcall	i2c_db
		rcall	i2c_db
		rjmp	end_drawsymbol
mark32:	cpi		temp1,31		//M
		brne	mark33
		drbyte	0b01111111
		drbyte	0b00000010
		drbyte	0b00001100
		drbyte	0b00000010
		drbyte	0b01111111
		rjmp	end_drawsymbol
mark33:	cpi		temp1,32		//N
		brne	mark34
		drbyte	0b01111111
		drbyte	0b00000100
		drbyte	0b00001000
		drbyte	0b00010000
		drbyte	0b01111111
		rjmp	end_drawsymbol	
mark34:	cpi		temp1,33		//O
		brne	mark35
		drbyte	0b00111110
		drbyte	0b01000001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00111110
		rjmp	end_drawsymbol
mark35:	cpi		temp1,34		//P
		brne	mark36
		drbyte	0b01111111
		drbyte	0b00010001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00001110
		rjmp	end_drawsymbol
mark36:	cpi		temp1,35		//Q
		brne	mark37
		drbyte	0b00001110
		drbyte	0b00010001
		drbyte	0b01110001
		drbyte	0b01010001
		drbyte	0b01001110
		rjmp	end_drawsymbol
mark37:	cpi		temp1,36		//R
		brne	mark38
		drbyte	0b01111111
		drbyte	0b00001001
		drbyte	0b00011001
		drbyte	0b00101001
		drbyte	0b01000110
		rjmp	end_drawsymbol
mark38:	cpi		temp1,37		//S
		brne	mark39
		drbyte	0b00100110
		drbyte	0b01001001
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00110010
		rjmp	end_drawsymbol
mark39:	cpi		temp1,38		//T
		brne	mark40
		drbyte	0b00000001
		rcall	i2c_db
		drbyte	0b01111111
		drbyte	0b00000001
		rcall	i2c_db
		rjmp	end_drawsymbol
mark40:	cpi		temp1,39		//U
		brne	mark41
		drbyte	0b00111111
		drbyte	0b01000000
		rcall	i2c_db
		rcall	i2c_db
		drbyte	0b00111111
		rjmp	end_drawsymbol
mark41:	cpi		temp1,40		//V
		brne	mark42
		drbyte	0b00000011
		drbyte	0b00011100
		drbyte	0b01100000
		drbyte	0b00011100
		drbyte	0b00000011
		rjmp	end_drawsymbol
mark42:	cpi		temp1,41		//W
		brne	mark43
		drbyte	0b01111111
		drbyte	0b00100000
		drbyte	0b00011000
		drbyte	0b00100000
		drbyte	0b01111111
		rjmp	end_drawsymbol
mark43:	cpi		temp1,42		//X
		brne	mark44
		drbyte	0b01000001
		drbyte	0b00110110
		drbyte	0b00001000
		drbyte	0b00110110
		drbyte	0b01000001
		rjmp	end_drawsymbol
mark44:	cpi		temp1,43		//Y
		brne	mark45
		drbyte	0b00000011
		drbyte	0b00000100
		drbyte	0b01111000
		drbyte	0b00000100
		drbyte	0b00000011
		rjmp	end_drawsymbol
mark45:	cpi		temp1,44		//Z
		brne	mark46
		drbyte	0b01100001
		drbyte	0b01010001
		drbyte	0b01001001
		drbyte	0b01000101
		drbyte	0b01000011
		rjmp	end_drawsymbol
mark46:	cpi		temp1,45		//%
		brne	mark47
		drbyte	0b01000110
		drbyte	0b00101001
		drbyte	0b00011001
		drbyte	0b00111110
		drbyte	0b01001100
		drbyte	0b01001010
		drbyte	0b00110001
		rjmp	end_drawsymbol
mark47:	cpi		temp1,46		//   
		brne	mark48
		ldi		temp1,0b00000000// X  
		sts		xcur,temp1
		lds		temp1,ycur		// Y
		bst		temp1,7
		brtc	b1
		andi	temp1,0b01111111
		tst		temp1
		breq	b1
		dec		temp1
		ori		temp1,0b10000000
		sts		ycur,temp1
		ret
b1:		inc		temp1
b2:		sts		ycur,temp1
		lds		temp2,xcur
		lds		temp3,ycur
		rcall	set_cur
		ret
mark48:	cpi		temp1,47		//)
		brne	mark49
		drbyte	0b01000001
		drbyte	0b00100010
		drbyte	0b00011100
		rjmp	end_drawsymbol
mark49:	cpi		temp1,48		//(
		brne	mark50
		drbyte	0b00011100
		drbyte	0b00100010
		drbyte	0b01000001
		rjmp	end_drawsymbol
mark50: cpi		temp1,49		//'
		brne	end_drawsymbol
		drbyte	0b00001011
		drbyte	0b00000111
end_drawsymbol:drbyte	0x00
		ret

//   - 
// temp2 x 
// temp3 y 
set_cur:sts		xcur,temp2
		sts		ycur,temp3
		rcall	i2c_start
		i2c_out	0x78
		i2c_out	0x00
		i2c_out 0x30
		ori		temp3,0b01000000
		ori		temp2,0b10000000
		ldi		temp1,0b00000000
		or		temp1,temp3
		rcall	i2c_sb
		ldi		temp1,0b00000000
		or		temp1,temp2
		rcall	i2c_sb
		rcall	i2c_stop
		ret

clr_screen:
		ldi		temp1,0x40
clear2:	rcall	i2c_start
		push	temp1
		i2c_out	0x78
		i2c_out	0x00
		i2c_out 0x30
		pop		temp1
		rcall	i2c_sb
		inc		temp1
		push	temp1
		i2c_out	0x80
		rcall	i2c_stop
		rcall	clear_line
		pop		temp1
		cpi		temp1,0x48
		brne	clear2
		ret

read_eepr:
		ldi		temp2,0
		out		EEARL,temp2
		out		EEARH,temp2
		ldi		temp3,0b00000000
eeread:	lds		temp1,ycur
		bst		temp1,7
		brts	eeread2
		andi	temp1,0b01111111
		cpi		temp1,8
		breq	eeread4
		brpl	eeread4
eeread2:sbic	EECR,EEWE
		rjmp	eeread
		out		EEARL,temp3
		out		EEDR,temp1
		sbi		EECR,EERE
		in		temp1,EEDR
		push	temp1
		push	temp2
		push	temp3
		rcall	draw_symbol
		pop		temp3
		pop		temp2
		pop		temp1
eeread3:cpi		temp3,255
		brne	eeread6
		sbi		EEARH,0
		ldi		temp2,0
		out		EEARL,temp2
		ldi		temp3,0
		rjmp	eeread5
eeread6:inc		temp3
eeread5:cpi		temp1,255
		brne	eeread
eeread4:ret
